import type { DB } from "../../utils";
export declare const pgPushIntrospect: (db: DB, filters: string[], schemaFilters: string[]) => Promise<{
    schema: {
        tables: Record<string, {
            name: string;
            columns: Record<string, {
                isUnique?: any;
                default?: any;
                typeSchema?: string | undefined;
                uniqueName?: string | undefined;
                nullsNotDistinct?: boolean | undefined;
                name: string;
                type: string;
                primaryKey: boolean;
                notNull: boolean;
            }>;
            indexes: Record<string, {
                name: string;
                columns: string[];
                isUnique: boolean;
            }>;
            foreignKeys: Record<string, {
                onUpdate?: string | undefined;
                onDelete?: string | undefined;
                schemaTo?: string | undefined;
                name: string;
                tableFrom: string;
                columnsFrom: string[];
                tableTo: string;
                columnsTo: string[];
            }>;
            schema: string;
            compositePrimaryKeys: Record<string, {
                name: string;
                columns: string[];
            }>;
            uniqueConstraints: Record<string, {
                name: string;
                columns: string[];
                nullsNotDistinct: boolean;
            }>;
        }>;
        id: string;
        prevId: string;
        version: "6";
        dialect: "postgresql";
        schemas: Record<string, string>;
        _meta: {
            columns: Record<string, string>;
            tables: Record<string, string>;
            schemas: Record<string, string>;
        };
        enums: Record<string, {
            name: string;
            values: string[];
            schema: string;
        }>;
    };
}>;
