import type { DB, Proxy, SQLiteDB, SqliteProxy } from "../utils";
import type { PostgresCredentials } from "./validations/pg";
import type { MysqlCredentials } from "./validations/mysql";
import { SqliteCredentials } from "./validations/sqlite";
export declare const preparePostgresDB: (credentials: PostgresCredentials) => Promise<DB & {
    proxy: Proxy;
}>;
export declare const connectToMySQL: (it: MysqlCredentials) => Promise<{
    db: DB;
    proxy: Proxy;
    database: string;
}>;
export declare const connectToSQLite: (credentials: SqliteCredentials) => Promise<SQLiteDB & SqliteProxy>;
