import { TypeOf, ZodTypeAny } from "zod";
import { JsonStatement } from "./jsonStatements";
import { SQLiteSchemaSquashed } from "./serializer/sqliteSchema";
import { MySqlSchema, MySqlSchemaSquashed } from "./serializer/mysqlSchema";
import { PgSchema, PgSchemaSquashed } from "./serializer/pgSchema";
import { Named } from "./cli/commands/migrate";
export declare const makePatched: <T extends ZodTypeAny>(schema: T) => import("zod").ZodUnion<[import("zod").ZodObject<{
    type: import("zod").ZodLiteral<"added">;
    value: T;
}, "strip", ZodTypeAny, { [k_1 in keyof import("zod").objectUtil.addQuestionMarks<{
    type: "added";
    value: T["_output"];
}>]: import("zod").objectUtil.addQuestionMarks<{
    type: "added";
    value: T["_output"];
}>[k_1]; }, { [k_3 in keyof import("zod").objectUtil.addQuestionMarks<{
    type: "added";
    value: T["_input"];
}>]: import("zod").objectUtil.addQuestionMarks<{
    type: "added";
    value: T["_input"];
}>[k_3]; }>, import("zod").ZodObject<{
    type: import("zod").ZodLiteral<"deleted">;
    value: T;
}, "strip", ZodTypeAny, { [k_1_1 in keyof import("zod").objectUtil.addQuestionMarks<{
    type: "deleted";
    value: T["_output"];
}>]: import("zod").objectUtil.addQuestionMarks<{
    type: "deleted";
    value: T["_output"];
}>[k_1_1]; }, { [k_3_1 in keyof import("zod").objectUtil.addQuestionMarks<{
    type: "deleted";
    value: T["_input"];
}>]: import("zod").objectUtil.addQuestionMarks<{
    type: "deleted";
    value: T["_input"];
}>[k_3_1]; }>, import("zod").ZodObject<{
    type: import("zod").ZodLiteral<"changed">;
    old: T;
    new: T;
}, "strip", ZodTypeAny, { [k_1_2 in keyof import("zod").objectUtil.addQuestionMarks<{
    type: "changed";
    old: T["_output"];
    new: T["_output"];
}>]: import("zod").objectUtil.addQuestionMarks<{
    type: "changed";
    old: T["_output"];
    new: T["_output"];
}>[k_1_2]; }, { [k_3_2 in keyof import("zod").objectUtil.addQuestionMarks<{
    type: "changed";
    old: T["_input"];
    new: T["_input"];
}>]: import("zod").objectUtil.addQuestionMarks<{
    type: "changed";
    old: T["_input"];
    new: T["_input"];
}>[k_3_2]; }>]>;
export declare const makeSelfOrPatched: <T extends ZodTypeAny>(schema: T) => import("zod").ZodUnion<[import("zod").ZodObject<{
    type: import("zod").ZodLiteral<"none">;
    value: T;
}, "strip", ZodTypeAny, { [k_1 in keyof import("zod").objectUtil.addQuestionMarks<{
    type: "none";
    value: T["_output"];
}>]: import("zod").objectUtil.addQuestionMarks<{
    type: "none";
    value: T["_output"];
}>[k_1]; }, { [k_3 in keyof import("zod").objectUtil.addQuestionMarks<{
    type: "none";
    value: T["_input"];
}>]: import("zod").objectUtil.addQuestionMarks<{
    type: "none";
    value: T["_input"];
}>[k_3]; }>, import("zod").ZodObject<{
    type: import("zod").ZodLiteral<"added">;
    value: T;
}, "strip", ZodTypeAny, { [k_1_1 in keyof import("zod").objectUtil.addQuestionMarks<{
    type: "added";
    value: T["_output"];
}>]: import("zod").objectUtil.addQuestionMarks<{
    type: "added";
    value: T["_output"];
}>[k_1_1]; }, { [k_3_1 in keyof import("zod").objectUtil.addQuestionMarks<{
    type: "added";
    value: T["_input"];
}>]: import("zod").objectUtil.addQuestionMarks<{
    type: "added";
    value: T["_input"];
}>[k_3_1]; }>, import("zod").ZodObject<{
    type: import("zod").ZodLiteral<"deleted">;
    value: T;
}, "strip", ZodTypeAny, { [k_1_2 in keyof import("zod").objectUtil.addQuestionMarks<{
    type: "deleted";
    value: T["_output"];
}>]: import("zod").objectUtil.addQuestionMarks<{
    type: "deleted";
    value: T["_output"];
}>[k_1_2]; }, { [k_3_2 in keyof import("zod").objectUtil.addQuestionMarks<{
    type: "deleted";
    value: T["_input"];
}>]: import("zod").objectUtil.addQuestionMarks<{
    type: "deleted";
    value: T["_input"];
}>[k_3_2]; }>, import("zod").ZodObject<{
    type: import("zod").ZodLiteral<"changed">;
    old: T;
    new: T;
}, "strip", ZodTypeAny, { [k_1_3 in keyof import("zod").objectUtil.addQuestionMarks<{
    type: "changed";
    old: T["_output"];
    new: T["_output"];
}>]: import("zod").objectUtil.addQuestionMarks<{
    type: "changed";
    old: T["_output"];
    new: T["_output"];
}>[k_1_3]; }, { [k_3_3 in keyof import("zod").objectUtil.addQuestionMarks<{
    type: "changed";
    old: T["_input"];
    new: T["_input"];
}>]: import("zod").objectUtil.addQuestionMarks<{
    type: "changed";
    old: T["_input"];
    new: T["_input"];
}>[k_3_3]; }>]>;
declare const columnSchema: import("zod").ZodObject<{
    name: import("zod").ZodString;
    type: import("zod").ZodString;
    typeSchema: import("zod").ZodOptional<import("zod").ZodString>;
    primaryKey: import("zod").ZodOptional<import("zod").ZodBoolean>;
    default: import("zod").ZodOptional<import("zod").ZodAny>;
    notNull: import("zod").ZodOptional<import("zod").ZodBoolean>;
    autoincrement: import("zod").ZodOptional<import("zod").ZodBoolean>;
    onUpdate: import("zod").ZodOptional<import("zod").ZodBoolean>;
    isUnique: import("zod").ZodOptional<import("zod").ZodAny>;
    uniqueName: import("zod").ZodOptional<import("zod").ZodString>;
    nullsNotDistinct: import("zod").ZodOptional<import("zod").ZodBoolean>;
}, "strict", ZodTypeAny, {
    isUnique?: any;
    default?: any;
    onUpdate?: boolean | undefined;
    primaryKey?: boolean | undefined;
    notNull?: boolean | undefined;
    autoincrement?: boolean | undefined;
    typeSchema?: string | undefined;
    uniqueName?: string | undefined;
    nullsNotDistinct?: boolean | undefined;
    name: string;
    type: string;
}, {
    isUnique?: any;
    default?: any;
    onUpdate?: boolean | undefined;
    primaryKey?: boolean | undefined;
    notNull?: boolean | undefined;
    autoincrement?: boolean | undefined;
    typeSchema?: string | undefined;
    uniqueName?: string | undefined;
    nullsNotDistinct?: boolean | undefined;
    name: string;
    type: string;
}>;
declare const alteredColumnSchema: import("zod").ZodObject<{
    name: import("zod").ZodUnion<[import("zod").ZodString, import("zod").ZodObject<{
        type: import("zod").ZodEnum<["changed"]>;
        old: import("zod").ZodString;
        new: import("zod").ZodString;
    }, "strip", ZodTypeAny, {
        type: "changed";
        old: string;
        new: string;
    }, {
        type: "changed";
        old: string;
        new: string;
    }>]>;
    type: import("zod").ZodOptional<import("zod").ZodObject<{
        type: import("zod").ZodEnum<["changed"]>;
        old: import("zod").ZodString;
        new: import("zod").ZodString;
    }, "strip", ZodTypeAny, {
        type: "changed";
        old: string;
        new: string;
    }, {
        type: "changed";
        old: string;
        new: string;
    }>>;
    default: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"added">;
        value: import("zod").ZodAny;
    }, "strip", ZodTypeAny, {
        value?: any;
        type: "added";
    }, {
        value?: any;
        type: "added";
    }>, import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"deleted">;
        value: import("zod").ZodAny;
    }, "strip", ZodTypeAny, {
        value?: any;
        type: "deleted";
    }, {
        value?: any;
        type: "deleted";
    }>, import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"changed">;
        old: import("zod").ZodAny;
        new: import("zod").ZodAny;
    }, "strip", ZodTypeAny, {
        old?: any;
        new?: any;
        type: "changed";
    }, {
        old?: any;
        new?: any;
        type: "changed";
    }>]>>;
    primaryKey: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"added">;
        value: import("zod").ZodBoolean;
    }, "strip", ZodTypeAny, {
        type: "added";
        value: boolean;
    }, {
        type: "added";
        value: boolean;
    }>, import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"deleted">;
        value: import("zod").ZodBoolean;
    }, "strip", ZodTypeAny, {
        type: "deleted";
        value: boolean;
    }, {
        type: "deleted";
        value: boolean;
    }>, import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"changed">;
        old: import("zod").ZodBoolean;
        new: import("zod").ZodBoolean;
    }, "strip", ZodTypeAny, {
        type: "changed";
        old: boolean;
        new: boolean;
    }, {
        type: "changed";
        old: boolean;
        new: boolean;
    }>]>>;
    notNull: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"added">;
        value: import("zod").ZodBoolean;
    }, "strip", ZodTypeAny, {
        type: "added";
        value: boolean;
    }, {
        type: "added";
        value: boolean;
    }>, import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"deleted">;
        value: import("zod").ZodBoolean;
    }, "strip", ZodTypeAny, {
        type: "deleted";
        value: boolean;
    }, {
        type: "deleted";
        value: boolean;
    }>, import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"changed">;
        old: import("zod").ZodBoolean;
        new: import("zod").ZodBoolean;
    }, "strip", ZodTypeAny, {
        type: "changed";
        old: boolean;
        new: boolean;
    }, {
        type: "changed";
        old: boolean;
        new: boolean;
    }>]>>;
    typeSchema: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"added">;
        value: import("zod").ZodString;
    }, "strip", ZodTypeAny, {
        type: "added";
        value: string;
    }, {
        type: "added";
        value: string;
    }>, import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"deleted">;
        value: import("zod").ZodString;
    }, "strip", ZodTypeAny, {
        type: "deleted";
        value: string;
    }, {
        type: "deleted";
        value: string;
    }>, import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"changed">;
        old: import("zod").ZodString;
        new: import("zod").ZodString;
    }, "strip", ZodTypeAny, {
        type: "changed";
        old: string;
        new: string;
    }, {
        type: "changed";
        old: string;
        new: string;
    }>]>>;
    onUpdate: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"added">;
        value: import("zod").ZodBoolean;
    }, "strip", ZodTypeAny, {
        type: "added";
        value: boolean;
    }, {
        type: "added";
        value: boolean;
    }>, import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"deleted">;
        value: import("zod").ZodBoolean;
    }, "strip", ZodTypeAny, {
        type: "deleted";
        value: boolean;
    }, {
        type: "deleted";
        value: boolean;
    }>, import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"changed">;
        old: import("zod").ZodBoolean;
        new: import("zod").ZodBoolean;
    }, "strip", ZodTypeAny, {
        type: "changed";
        old: boolean;
        new: boolean;
    }, {
        type: "changed";
        old: boolean;
        new: boolean;
    }>]>>;
    autoincrement: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"added">;
        value: import("zod").ZodBoolean;
    }, "strip", ZodTypeAny, {
        type: "added";
        value: boolean;
    }, {
        type: "added";
        value: boolean;
    }>, import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"deleted">;
        value: import("zod").ZodBoolean;
    }, "strip", ZodTypeAny, {
        type: "deleted";
        value: boolean;
    }, {
        type: "deleted";
        value: boolean;
    }>, import("zod").ZodObject<{
        type: import("zod").ZodLiteral<"changed">;
        old: import("zod").ZodBoolean;
        new: import("zod").ZodBoolean;
    }, "strip", ZodTypeAny, {
        type: "changed";
        old: boolean;
        new: boolean;
    }, {
        type: "changed";
        old: boolean;
        new: boolean;
    }>]>>;
}, "strict", ZodTypeAny, {
    default?: {
        value?: any;
        type: "added";
    } | {
        value?: any;
        type: "deleted";
    } | {
        old?: any;
        new?: any;
        type: "changed";
    } | undefined;
    type?: {
        type: "changed";
        old: string;
        new: string;
    } | undefined;
    onUpdate?: {
        type: "added";
        value: boolean;
    } | {
        type: "deleted";
        value: boolean;
    } | {
        type: "changed";
        old: boolean;
        new: boolean;
    } | undefined;
    primaryKey?: {
        type: "added";
        value: boolean;
    } | {
        type: "deleted";
        value: boolean;
    } | {
        type: "changed";
        old: boolean;
        new: boolean;
    } | undefined;
    notNull?: {
        type: "added";
        value: boolean;
    } | {
        type: "deleted";
        value: boolean;
    } | {
        type: "changed";
        old: boolean;
        new: boolean;
    } | undefined;
    autoincrement?: {
        type: "added";
        value: boolean;
    } | {
        type: "deleted";
        value: boolean;
    } | {
        type: "changed";
        old: boolean;
        new: boolean;
    } | undefined;
    typeSchema?: {
        type: "added";
        value: string;
    } | {
        type: "deleted";
        value: string;
    } | {
        type: "changed";
        old: string;
        new: string;
    } | undefined;
    name: string | {
        type: "changed";
        old: string;
        new: string;
    };
}, {
    default?: {
        value?: any;
        type: "added";
    } | {
        value?: any;
        type: "deleted";
    } | {
        old?: any;
        new?: any;
        type: "changed";
    } | undefined;
    type?: {
        type: "changed";
        old: string;
        new: string;
    } | undefined;
    onUpdate?: {
        type: "added";
        value: boolean;
    } | {
        type: "deleted";
        value: boolean;
    } | {
        type: "changed";
        old: boolean;
        new: boolean;
    } | undefined;
    primaryKey?: {
        type: "added";
        value: boolean;
    } | {
        type: "deleted";
        value: boolean;
    } | {
        type: "changed";
        old: boolean;
        new: boolean;
    } | undefined;
    notNull?: {
        type: "added";
        value: boolean;
    } | {
        type: "deleted";
        value: boolean;
    } | {
        type: "changed";
        old: boolean;
        new: boolean;
    } | undefined;
    autoincrement?: {
        type: "added";
        value: boolean;
    } | {
        type: "deleted";
        value: boolean;
    } | {
        type: "changed";
        old: boolean;
        new: boolean;
    } | undefined;
    typeSchema?: {
        type: "added";
        value: string;
    } | {
        type: "deleted";
        value: string;
    } | {
        type: "changed";
        old: string;
        new: string;
    } | undefined;
    name: string | {
        type: "changed";
        old: string;
        new: string;
    };
}>;
declare const enumSchema: import("zod").ZodObject<{
    name: import("zod").ZodString;
    schema: import("zod").ZodString;
    values: import("zod").ZodArray<import("zod").ZodString, "many">;
}, "strict", ZodTypeAny, {
    name: string;
    values: string[];
    schema: string;
}, {
    name: string;
    values: string[];
    schema: string;
}>;
declare const tableScheme: import("zod").ZodObject<{
    name: import("zod").ZodString;
    schema: import("zod").ZodDefault<import("zod").ZodString>;
    columns: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodObject<{
        name: import("zod").ZodString;
        type: import("zod").ZodString;
        typeSchema: import("zod").ZodOptional<import("zod").ZodString>;
        primaryKey: import("zod").ZodOptional<import("zod").ZodBoolean>;
        default: import("zod").ZodOptional<import("zod").ZodAny>;
        notNull: import("zod").ZodOptional<import("zod").ZodBoolean>;
        autoincrement: import("zod").ZodOptional<import("zod").ZodBoolean>;
        onUpdate: import("zod").ZodOptional<import("zod").ZodBoolean>;
        isUnique: import("zod").ZodOptional<import("zod").ZodAny>;
        uniqueName: import("zod").ZodOptional<import("zod").ZodString>;
        nullsNotDistinct: import("zod").ZodOptional<import("zod").ZodBoolean>;
    }, "strict", ZodTypeAny, {
        isUnique?: any;
        default?: any;
        onUpdate?: boolean | undefined;
        primaryKey?: boolean | undefined;
        notNull?: boolean | undefined;
        autoincrement?: boolean | undefined;
        typeSchema?: string | undefined;
        uniqueName?: string | undefined;
        nullsNotDistinct?: boolean | undefined;
        name: string;
        type: string;
    }, {
        isUnique?: any;
        default?: any;
        onUpdate?: boolean | undefined;
        primaryKey?: boolean | undefined;
        notNull?: boolean | undefined;
        autoincrement?: boolean | undefined;
        typeSchema?: string | undefined;
        uniqueName?: string | undefined;
        nullsNotDistinct?: boolean | undefined;
        name: string;
        type: string;
    }>>;
    indexes: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
    foreignKeys: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
    compositePrimaryKeys: import("zod").ZodDefault<import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>>;
    uniqueConstraints: import("zod").ZodDefault<import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>>;
}, "strict", ZodTypeAny, {
    name: string;
    columns: Record<string, {
        isUnique?: any;
        default?: any;
        onUpdate?: boolean | undefined;
        primaryKey?: boolean | undefined;
        notNull?: boolean | undefined;
        autoincrement?: boolean | undefined;
        typeSchema?: string | undefined;
        uniqueName?: string | undefined;
        nullsNotDistinct?: boolean | undefined;
        name: string;
        type: string;
    }>;
    indexes: Record<string, string>;
    foreignKeys: Record<string, string>;
    schema: string;
    compositePrimaryKeys: Record<string, string>;
    uniqueConstraints: Record<string, string>;
}, {
    schema?: string | undefined;
    compositePrimaryKeys?: Record<string, string> | undefined;
    uniqueConstraints?: Record<string, string> | undefined;
    name: string;
    columns: Record<string, {
        isUnique?: any;
        default?: any;
        onUpdate?: boolean | undefined;
        primaryKey?: boolean | undefined;
        notNull?: boolean | undefined;
        autoincrement?: boolean | undefined;
        typeSchema?: string | undefined;
        uniqueName?: string | undefined;
        nullsNotDistinct?: boolean | undefined;
        name: string;
        type: string;
    }>;
    indexes: Record<string, string>;
    foreignKeys: Record<string, string>;
}>;
export declare const alteredTableScheme: import("zod").ZodObject<{
    name: import("zod").ZodString;
    schema: import("zod").ZodString;
    altered: import("zod").ZodArray<import("zod").ZodObject<{
        name: import("zod").ZodUnion<[import("zod").ZodString, import("zod").ZodObject<{
            type: import("zod").ZodEnum<["changed"]>;
            old: import("zod").ZodString;
            new: import("zod").ZodString;
        }, "strip", ZodTypeAny, {
            type: "changed";
            old: string;
            new: string;
        }, {
            type: "changed";
            old: string;
            new: string;
        }>]>;
        type: import("zod").ZodOptional<import("zod").ZodObject<{
            type: import("zod").ZodEnum<["changed"]>;
            old: import("zod").ZodString;
            new: import("zod").ZodString;
        }, "strip", ZodTypeAny, {
            type: "changed";
            old: string;
            new: string;
        }, {
            type: "changed";
            old: string;
            new: string;
        }>>;
        default: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"added">;
            value: import("zod").ZodAny;
        }, "strip", ZodTypeAny, {
            value?: any;
            type: "added";
        }, {
            value?: any;
            type: "added";
        }>, import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"deleted">;
            value: import("zod").ZodAny;
        }, "strip", ZodTypeAny, {
            value?: any;
            type: "deleted";
        }, {
            value?: any;
            type: "deleted";
        }>, import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"changed">;
            old: import("zod").ZodAny;
            new: import("zod").ZodAny;
        }, "strip", ZodTypeAny, {
            old?: any;
            new?: any;
            type: "changed";
        }, {
            old?: any;
            new?: any;
            type: "changed";
        }>]>>;
        primaryKey: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"added">;
            value: import("zod").ZodBoolean;
        }, "strip", ZodTypeAny, {
            type: "added";
            value: boolean;
        }, {
            type: "added";
            value: boolean;
        }>, import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"deleted">;
            value: import("zod").ZodBoolean;
        }, "strip", ZodTypeAny, {
            type: "deleted";
            value: boolean;
        }, {
            type: "deleted";
            value: boolean;
        }>, import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"changed">;
            old: import("zod").ZodBoolean;
            new: import("zod").ZodBoolean;
        }, "strip", ZodTypeAny, {
            type: "changed";
            old: boolean;
            new: boolean;
        }, {
            type: "changed";
            old: boolean;
            new: boolean;
        }>]>>;
        notNull: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"added">;
            value: import("zod").ZodBoolean;
        }, "strip", ZodTypeAny, {
            type: "added";
            value: boolean;
        }, {
            type: "added";
            value: boolean;
        }>, import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"deleted">;
            value: import("zod").ZodBoolean;
        }, "strip", ZodTypeAny, {
            type: "deleted";
            value: boolean;
        }, {
            type: "deleted";
            value: boolean;
        }>, import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"changed">;
            old: import("zod").ZodBoolean;
            new: import("zod").ZodBoolean;
        }, "strip", ZodTypeAny, {
            type: "changed";
            old: boolean;
            new: boolean;
        }, {
            type: "changed";
            old: boolean;
            new: boolean;
        }>]>>;
        typeSchema: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"added">;
            value: import("zod").ZodString;
        }, "strip", ZodTypeAny, {
            type: "added";
            value: string;
        }, {
            type: "added";
            value: string;
        }>, import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"deleted">;
            value: import("zod").ZodString;
        }, "strip", ZodTypeAny, {
            type: "deleted";
            value: string;
        }, {
            type: "deleted";
            value: string;
        }>, import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"changed">;
            old: import("zod").ZodString;
            new: import("zod").ZodString;
        }, "strip", ZodTypeAny, {
            type: "changed";
            old: string;
            new: string;
        }, {
            type: "changed";
            old: string;
            new: string;
        }>]>>;
        onUpdate: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"added">;
            value: import("zod").ZodBoolean;
        }, "strip", ZodTypeAny, {
            type: "added";
            value: boolean;
        }, {
            type: "added";
            value: boolean;
        }>, import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"deleted">;
            value: import("zod").ZodBoolean;
        }, "strip", ZodTypeAny, {
            type: "deleted";
            value: boolean;
        }, {
            type: "deleted";
            value: boolean;
        }>, import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"changed">;
            old: import("zod").ZodBoolean;
            new: import("zod").ZodBoolean;
        }, "strip", ZodTypeAny, {
            type: "changed";
            old: boolean;
            new: boolean;
        }, {
            type: "changed";
            old: boolean;
            new: boolean;
        }>]>>;
        autoincrement: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"added">;
            value: import("zod").ZodBoolean;
        }, "strip", ZodTypeAny, {
            type: "added";
            value: boolean;
        }, {
            type: "added";
            value: boolean;
        }>, import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"deleted">;
            value: import("zod").ZodBoolean;
        }, "strip", ZodTypeAny, {
            type: "deleted";
            value: boolean;
        }, {
            type: "deleted";
            value: boolean;
        }>, import("zod").ZodObject<{
            type: import("zod").ZodLiteral<"changed">;
            old: import("zod").ZodBoolean;
            new: import("zod").ZodBoolean;
        }, "strip", ZodTypeAny, {
            type: "changed";
            old: boolean;
            new: boolean;
        }, {
            type: "changed";
            old: boolean;
            new: boolean;
        }>]>>;
    }, "strict", ZodTypeAny, {
        default?: {
            value?: any;
            type: "added";
        } | {
            value?: any;
            type: "deleted";
        } | {
            old?: any;
            new?: any;
            type: "changed";
        } | undefined;
        type?: {
            type: "changed";
            old: string;
            new: string;
        } | undefined;
        onUpdate?: {
            type: "added";
            value: boolean;
        } | {
            type: "deleted";
            value: boolean;
        } | {
            type: "changed";
            old: boolean;
            new: boolean;
        } | undefined;
        primaryKey?: {
            type: "added";
            value: boolean;
        } | {
            type: "deleted";
            value: boolean;
        } | {
            type: "changed";
            old: boolean;
            new: boolean;
        } | undefined;
        notNull?: {
            type: "added";
            value: boolean;
        } | {
            type: "deleted";
            value: boolean;
        } | {
            type: "changed";
            old: boolean;
            new: boolean;
        } | undefined;
        autoincrement?: {
            type: "added";
            value: boolean;
        } | {
            type: "deleted";
            value: boolean;
        } | {
            type: "changed";
            old: boolean;
            new: boolean;
        } | undefined;
        typeSchema?: {
            type: "added";
            value: string;
        } | {
            type: "deleted";
            value: string;
        } | {
            type: "changed";
            old: string;
            new: string;
        } | undefined;
        name: string | {
            type: "changed";
            old: string;
            new: string;
        };
    }, {
        default?: {
            value?: any;
            type: "added";
        } | {
            value?: any;
            type: "deleted";
        } | {
            old?: any;
            new?: any;
            type: "changed";
        } | undefined;
        type?: {
            type: "changed";
            old: string;
            new: string;
        } | undefined;
        onUpdate?: {
            type: "added";
            value: boolean;
        } | {
            type: "deleted";
            value: boolean;
        } | {
            type: "changed";
            old: boolean;
            new: boolean;
        } | undefined;
        primaryKey?: {
            type: "added";
            value: boolean;
        } | {
            type: "deleted";
            value: boolean;
        } | {
            type: "changed";
            old: boolean;
            new: boolean;
        } | undefined;
        notNull?: {
            type: "added";
            value: boolean;
        } | {
            type: "deleted";
            value: boolean;
        } | {
            type: "changed";
            old: boolean;
            new: boolean;
        } | undefined;
        autoincrement?: {
            type: "added";
            value: boolean;
        } | {
            type: "deleted";
            value: boolean;
        } | {
            type: "changed";
            old: boolean;
            new: boolean;
        } | undefined;
        typeSchema?: {
            type: "added";
            value: string;
        } | {
            type: "deleted";
            value: string;
        } | {
            type: "changed";
            old: string;
            new: string;
        } | undefined;
        name: string | {
            type: "changed";
            old: string;
            new: string;
        };
    }>, "many">;
    addedIndexes: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
    deletedIndexes: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
    alteredIndexes: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodObject<{
        __new: import("zod").ZodString;
        __old: import("zod").ZodString;
    }, "strict", ZodTypeAny, {
        __old: string;
        __new: string;
    }, {
        __old: string;
        __new: string;
    }>>;
    addedForeignKeys: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
    deletedForeignKeys: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
    alteredForeignKeys: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodObject<{
        __new: import("zod").ZodString;
        __old: import("zod").ZodString;
    }, "strict", ZodTypeAny, {
        __old: string;
        __new: string;
    }, {
        __old: string;
        __new: string;
    }>>;
    addedCompositePKs: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
    deletedCompositePKs: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
    alteredCompositePKs: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodObject<{
        __new: import("zod").ZodString;
        __old: import("zod").ZodString;
    }, "strip", ZodTypeAny, {
        __old: string;
        __new: string;
    }, {
        __old: string;
        __new: string;
    }>>;
    addedUniqueConstraints: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
    deletedUniqueConstraints: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
    alteredUniqueConstraints: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodObject<{
        __new: import("zod").ZodString;
        __old: import("zod").ZodString;
    }, "strip", ZodTypeAny, {
        __old: string;
        __new: string;
    }, {
        __old: string;
        __new: string;
    }>>;
}, "strict", ZodTypeAny, {
    name: string;
    schema: string;
    altered: {
        default?: {
            value?: any;
            type: "added";
        } | {
            value?: any;
            type: "deleted";
        } | {
            old?: any;
            new?: any;
            type: "changed";
        } | undefined;
        type?: {
            type: "changed";
            old: string;
            new: string;
        } | undefined;
        onUpdate?: {
            type: "added";
            value: boolean;
        } | {
            type: "deleted";
            value: boolean;
        } | {
            type: "changed";
            old: boolean;
            new: boolean;
        } | undefined;
        primaryKey?: {
            type: "added";
            value: boolean;
        } | {
            type: "deleted";
            value: boolean;
        } | {
            type: "changed";
            old: boolean;
            new: boolean;
        } | undefined;
        notNull?: {
            type: "added";
            value: boolean;
        } | {
            type: "deleted";
            value: boolean;
        } | {
            type: "changed";
            old: boolean;
            new: boolean;
        } | undefined;
        autoincrement?: {
            type: "added";
            value: boolean;
        } | {
            type: "deleted";
            value: boolean;
        } | {
            type: "changed";
            old: boolean;
            new: boolean;
        } | undefined;
        typeSchema?: {
            type: "added";
            value: string;
        } | {
            type: "deleted";
            value: string;
        } | {
            type: "changed";
            old: string;
            new: string;
        } | undefined;
        name: string | {
            type: "changed";
            old: string;
            new: string;
        };
    }[];
    addedIndexes: Record<string, string>;
    deletedIndexes: Record<string, string>;
    alteredIndexes: Record<string, {
        __old: string;
        __new: string;
    }>;
    addedForeignKeys: Record<string, string>;
    deletedForeignKeys: Record<string, string>;
    alteredForeignKeys: Record<string, {
        __old: string;
        __new: string;
    }>;
    addedCompositePKs: Record<string, string>;
    deletedCompositePKs: Record<string, string>;
    alteredCompositePKs: Record<string, {
        __old: string;
        __new: string;
    }>;
    addedUniqueConstraints: Record<string, string>;
    deletedUniqueConstraints: Record<string, string>;
    alteredUniqueConstraints: Record<string, {
        __old: string;
        __new: string;
    }>;
}, {
    name: string;
    schema: string;
    altered: {
        default?: {
            value?: any;
            type: "added";
        } | {
            value?: any;
            type: "deleted";
        } | {
            old?: any;
            new?: any;
            type: "changed";
        } | undefined;
        type?: {
            type: "changed";
            old: string;
            new: string;
        } | undefined;
        onUpdate?: {
            type: "added";
            value: boolean;
        } | {
            type: "deleted";
            value: boolean;
        } | {
            type: "changed";
            old: boolean;
            new: boolean;
        } | undefined;
        primaryKey?: {
            type: "added";
            value: boolean;
        } | {
            type: "deleted";
            value: boolean;
        } | {
            type: "changed";
            old: boolean;
            new: boolean;
        } | undefined;
        notNull?: {
            type: "added";
            value: boolean;
        } | {
            type: "deleted";
            value: boolean;
        } | {
            type: "changed";
            old: boolean;
            new: boolean;
        } | undefined;
        autoincrement?: {
            type: "added";
            value: boolean;
        } | {
            type: "deleted";
            value: boolean;
        } | {
            type: "changed";
            old: boolean;
            new: boolean;
        } | undefined;
        typeSchema?: {
            type: "added";
            value: string;
        } | {
            type: "deleted";
            value: string;
        } | {
            type: "changed";
            old: string;
            new: string;
        } | undefined;
        name: string | {
            type: "changed";
            old: string;
            new: string;
        };
    }[];
    addedIndexes: Record<string, string>;
    deletedIndexes: Record<string, string>;
    alteredIndexes: Record<string, {
        __old: string;
        __new: string;
    }>;
    addedForeignKeys: Record<string, string>;
    deletedForeignKeys: Record<string, string>;
    alteredForeignKeys: Record<string, {
        __old: string;
        __new: string;
    }>;
    addedCompositePKs: Record<string, string>;
    deletedCompositePKs: Record<string, string>;
    alteredCompositePKs: Record<string, {
        __old: string;
        __new: string;
    }>;
    addedUniqueConstraints: Record<string, string>;
    deletedUniqueConstraints: Record<string, string>;
    alteredUniqueConstraints: Record<string, {
        __old: string;
        __new: string;
    }>;
}>;
export declare const diffResultScheme: import("zod").ZodObject<{
    alteredTablesWithColumns: import("zod").ZodArray<import("zod").ZodObject<{
        name: import("zod").ZodString;
        schema: import("zod").ZodString;
        altered: import("zod").ZodArray<import("zod").ZodObject<{
            name: import("zod").ZodUnion<[import("zod").ZodString, import("zod").ZodObject<{
                type: import("zod").ZodEnum<["changed"]>;
                old: import("zod").ZodString;
                new: import("zod").ZodString;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: string;
                new: string;
            }, {
                type: "changed";
                old: string;
                new: string;
            }>]>;
            type: import("zod").ZodOptional<import("zod").ZodObject<{
                type: import("zod").ZodEnum<["changed"]>;
                old: import("zod").ZodString;
                new: import("zod").ZodString;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: string;
                new: string;
            }, {
                type: "changed";
                old: string;
                new: string;
            }>>;
            default: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodAny;
            }, "strip", ZodTypeAny, {
                value?: any;
                type: "added";
            }, {
                value?: any;
                type: "added";
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodAny;
            }, "strip", ZodTypeAny, {
                value?: any;
                type: "deleted";
            }, {
                value?: any;
                type: "deleted";
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodAny;
                new: import("zod").ZodAny;
            }, "strip", ZodTypeAny, {
                old?: any;
                new?: any;
                type: "changed";
            }, {
                old?: any;
                new?: any;
                type: "changed";
            }>]>>;
            primaryKey: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "added";
                value: boolean;
            }, {
                type: "added";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "deleted";
                value: boolean;
            }, {
                type: "deleted";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodBoolean;
                new: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: boolean;
                new: boolean;
            }, {
                type: "changed";
                old: boolean;
                new: boolean;
            }>]>>;
            notNull: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "added";
                value: boolean;
            }, {
                type: "added";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "deleted";
                value: boolean;
            }, {
                type: "deleted";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodBoolean;
                new: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: boolean;
                new: boolean;
            }, {
                type: "changed";
                old: boolean;
                new: boolean;
            }>]>>;
            typeSchema: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodString;
            }, "strip", ZodTypeAny, {
                type: "added";
                value: string;
            }, {
                type: "added";
                value: string;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodString;
            }, "strip", ZodTypeAny, {
                type: "deleted";
                value: string;
            }, {
                type: "deleted";
                value: string;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodString;
                new: import("zod").ZodString;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: string;
                new: string;
            }, {
                type: "changed";
                old: string;
                new: string;
            }>]>>;
            onUpdate: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "added";
                value: boolean;
            }, {
                type: "added";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "deleted";
                value: boolean;
            }, {
                type: "deleted";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodBoolean;
                new: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: boolean;
                new: boolean;
            }, {
                type: "changed";
                old: boolean;
                new: boolean;
            }>]>>;
            autoincrement: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "added";
                value: boolean;
            }, {
                type: "added";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "deleted";
                value: boolean;
            }, {
                type: "deleted";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodBoolean;
                new: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: boolean;
                new: boolean;
            }, {
                type: "changed";
                old: boolean;
                new: boolean;
            }>]>>;
        }, "strict", ZodTypeAny, {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }, {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }>, "many">;
        addedIndexes: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        deletedIndexes: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        alteredIndexes: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodObject<{
            __new: import("zod").ZodString;
            __old: import("zod").ZodString;
        }, "strict", ZodTypeAny, {
            __old: string;
            __new: string;
        }, {
            __old: string;
            __new: string;
        }>>;
        addedForeignKeys: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        deletedForeignKeys: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        alteredForeignKeys: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodObject<{
            __new: import("zod").ZodString;
            __old: import("zod").ZodString;
        }, "strict", ZodTypeAny, {
            __old: string;
            __new: string;
        }, {
            __old: string;
            __new: string;
        }>>;
        addedCompositePKs: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        deletedCompositePKs: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        alteredCompositePKs: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodObject<{
            __new: import("zod").ZodString;
            __old: import("zod").ZodString;
        }, "strip", ZodTypeAny, {
            __old: string;
            __new: string;
        }, {
            __old: string;
            __new: string;
        }>>;
        addedUniqueConstraints: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        deletedUniqueConstraints: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        alteredUniqueConstraints: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodObject<{
            __new: import("zod").ZodString;
            __old: import("zod").ZodString;
        }, "strip", ZodTypeAny, {
            __old: string;
            __new: string;
        }, {
            __old: string;
            __new: string;
        }>>;
    }, "strict", ZodTypeAny, {
        name: string;
        schema: string;
        altered: {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }[];
        addedIndexes: Record<string, string>;
        deletedIndexes: Record<string, string>;
        alteredIndexes: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedForeignKeys: Record<string, string>;
        deletedForeignKeys: Record<string, string>;
        alteredForeignKeys: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedCompositePKs: Record<string, string>;
        deletedCompositePKs: Record<string, string>;
        alteredCompositePKs: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedUniqueConstraints: Record<string, string>;
        deletedUniqueConstraints: Record<string, string>;
        alteredUniqueConstraints: Record<string, {
            __old: string;
            __new: string;
        }>;
    }, {
        name: string;
        schema: string;
        altered: {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }[];
        addedIndexes: Record<string, string>;
        deletedIndexes: Record<string, string>;
        alteredIndexes: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedForeignKeys: Record<string, string>;
        deletedForeignKeys: Record<string, string>;
        alteredForeignKeys: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedCompositePKs: Record<string, string>;
        deletedCompositePKs: Record<string, string>;
        alteredCompositePKs: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedUniqueConstraints: Record<string, string>;
        deletedUniqueConstraints: Record<string, string>;
        alteredUniqueConstraints: Record<string, {
            __old: string;
            __new: string;
        }>;
    }>, "many">;
    alteredEnums: import("zod").ZodArray<import("zod").ZodObject<{
        name: import("zod").ZodString;
        schema: import("zod").ZodString;
        addedValues: import("zod").ZodArray<import("zod").ZodObject<{
            before: import("zod").ZodString;
            value: import("zod").ZodString;
        }, "strip", ZodTypeAny, {
            value: string;
            before: string;
        }, {
            value: string;
            before: string;
        }>, "many">;
        deletedValues: import("zod").ZodArray<import("zod").ZodString, "many">;
    }, "strict", ZodTypeAny, {
        name: string;
        schema: string;
        addedValues: {
            value: string;
            before: string;
        }[];
        deletedValues: string[];
    }, {
        name: string;
        schema: string;
        addedValues: {
            value: string;
            before: string;
        }[];
        deletedValues: string[];
    }>, "many">;
}, "strict", ZodTypeAny, {
    alteredTablesWithColumns: {
        name: string;
        schema: string;
        altered: {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }[];
        addedIndexes: Record<string, string>;
        deletedIndexes: Record<string, string>;
        alteredIndexes: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedForeignKeys: Record<string, string>;
        deletedForeignKeys: Record<string, string>;
        alteredForeignKeys: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedCompositePKs: Record<string, string>;
        deletedCompositePKs: Record<string, string>;
        alteredCompositePKs: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedUniqueConstraints: Record<string, string>;
        deletedUniqueConstraints: Record<string, string>;
        alteredUniqueConstraints: Record<string, {
            __old: string;
            __new: string;
        }>;
    }[];
    alteredEnums: {
        name: string;
        schema: string;
        addedValues: {
            value: string;
            before: string;
        }[];
        deletedValues: string[];
    }[];
}, {
    alteredTablesWithColumns: {
        name: string;
        schema: string;
        altered: {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }[];
        addedIndexes: Record<string, string>;
        deletedIndexes: Record<string, string>;
        alteredIndexes: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedForeignKeys: Record<string, string>;
        deletedForeignKeys: Record<string, string>;
        alteredForeignKeys: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedCompositePKs: Record<string, string>;
        deletedCompositePKs: Record<string, string>;
        alteredCompositePKs: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedUniqueConstraints: Record<string, string>;
        deletedUniqueConstraints: Record<string, string>;
        alteredUniqueConstraints: Record<string, {
            __old: string;
            __new: string;
        }>;
    }[];
    alteredEnums: {
        name: string;
        schema: string;
        addedValues: {
            value: string;
            before: string;
        }[];
        deletedValues: string[];
    }[];
}>;
export declare const diffResultSchemeMysql: import("zod").ZodObject<{
    alteredTablesWithColumns: import("zod").ZodArray<import("zod").ZodObject<{
        name: import("zod").ZodString;
        schema: import("zod").ZodString;
        altered: import("zod").ZodArray<import("zod").ZodObject<{
            name: import("zod").ZodUnion<[import("zod").ZodString, import("zod").ZodObject<{
                type: import("zod").ZodEnum<["changed"]>;
                old: import("zod").ZodString;
                new: import("zod").ZodString;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: string;
                new: string;
            }, {
                type: "changed";
                old: string;
                new: string;
            }>]>;
            type: import("zod").ZodOptional<import("zod").ZodObject<{
                type: import("zod").ZodEnum<["changed"]>;
                old: import("zod").ZodString;
                new: import("zod").ZodString;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: string;
                new: string;
            }, {
                type: "changed";
                old: string;
                new: string;
            }>>;
            default: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodAny;
            }, "strip", ZodTypeAny, {
                value?: any;
                type: "added";
            }, {
                value?: any;
                type: "added";
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodAny;
            }, "strip", ZodTypeAny, {
                value?: any;
                type: "deleted";
            }, {
                value?: any;
                type: "deleted";
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodAny;
                new: import("zod").ZodAny;
            }, "strip", ZodTypeAny, {
                old?: any;
                new?: any;
                type: "changed";
            }, {
                old?: any;
                new?: any;
                type: "changed";
            }>]>>;
            primaryKey: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "added";
                value: boolean;
            }, {
                type: "added";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "deleted";
                value: boolean;
            }, {
                type: "deleted";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodBoolean;
                new: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: boolean;
                new: boolean;
            }, {
                type: "changed";
                old: boolean;
                new: boolean;
            }>]>>;
            notNull: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "added";
                value: boolean;
            }, {
                type: "added";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "deleted";
                value: boolean;
            }, {
                type: "deleted";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodBoolean;
                new: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: boolean;
                new: boolean;
            }, {
                type: "changed";
                old: boolean;
                new: boolean;
            }>]>>;
            typeSchema: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodString;
            }, "strip", ZodTypeAny, {
                type: "added";
                value: string;
            }, {
                type: "added";
                value: string;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodString;
            }, "strip", ZodTypeAny, {
                type: "deleted";
                value: string;
            }, {
                type: "deleted";
                value: string;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodString;
                new: import("zod").ZodString;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: string;
                new: string;
            }, {
                type: "changed";
                old: string;
                new: string;
            }>]>>;
            onUpdate: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "added";
                value: boolean;
            }, {
                type: "added";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "deleted";
                value: boolean;
            }, {
                type: "deleted";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodBoolean;
                new: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: boolean;
                new: boolean;
            }, {
                type: "changed";
                old: boolean;
                new: boolean;
            }>]>>;
            autoincrement: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "added";
                value: boolean;
            }, {
                type: "added";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "deleted";
                value: boolean;
            }, {
                type: "deleted";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodBoolean;
                new: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: boolean;
                new: boolean;
            }, {
                type: "changed";
                old: boolean;
                new: boolean;
            }>]>>;
        }, "strict", ZodTypeAny, {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }, {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }>, "many">;
        addedIndexes: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        deletedIndexes: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        alteredIndexes: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodObject<{
            __new: import("zod").ZodString;
            __old: import("zod").ZodString;
        }, "strict", ZodTypeAny, {
            __old: string;
            __new: string;
        }, {
            __old: string;
            __new: string;
        }>>;
        addedForeignKeys: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        deletedForeignKeys: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        alteredForeignKeys: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodObject<{
            __new: import("zod").ZodString;
            __old: import("zod").ZodString;
        }, "strict", ZodTypeAny, {
            __old: string;
            __new: string;
        }, {
            __old: string;
            __new: string;
        }>>;
        addedCompositePKs: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        deletedCompositePKs: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        alteredCompositePKs: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodObject<{
            __new: import("zod").ZodString;
            __old: import("zod").ZodString;
        }, "strip", ZodTypeAny, {
            __old: string;
            __new: string;
        }, {
            __old: string;
            __new: string;
        }>>;
        addedUniqueConstraints: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        deletedUniqueConstraints: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        alteredUniqueConstraints: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodObject<{
            __new: import("zod").ZodString;
            __old: import("zod").ZodString;
        }, "strip", ZodTypeAny, {
            __old: string;
            __new: string;
        }, {
            __old: string;
            __new: string;
        }>>;
    }, "strict", ZodTypeAny, {
        name: string;
        schema: string;
        altered: {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }[];
        addedIndexes: Record<string, string>;
        deletedIndexes: Record<string, string>;
        alteredIndexes: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedForeignKeys: Record<string, string>;
        deletedForeignKeys: Record<string, string>;
        alteredForeignKeys: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedCompositePKs: Record<string, string>;
        deletedCompositePKs: Record<string, string>;
        alteredCompositePKs: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedUniqueConstraints: Record<string, string>;
        deletedUniqueConstraints: Record<string, string>;
        alteredUniqueConstraints: Record<string, {
            __old: string;
            __new: string;
        }>;
    }, {
        name: string;
        schema: string;
        altered: {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }[];
        addedIndexes: Record<string, string>;
        deletedIndexes: Record<string, string>;
        alteredIndexes: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedForeignKeys: Record<string, string>;
        deletedForeignKeys: Record<string, string>;
        alteredForeignKeys: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedCompositePKs: Record<string, string>;
        deletedCompositePKs: Record<string, string>;
        alteredCompositePKs: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedUniqueConstraints: Record<string, string>;
        deletedUniqueConstraints: Record<string, string>;
        alteredUniqueConstraints: Record<string, {
            __old: string;
            __new: string;
        }>;
    }>, "many">;
    alteredEnums: import("zod").ZodArray<import("zod").ZodNever, "many">;
}, "strict", ZodTypeAny, {
    alteredTablesWithColumns: {
        name: string;
        schema: string;
        altered: {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }[];
        addedIndexes: Record<string, string>;
        deletedIndexes: Record<string, string>;
        alteredIndexes: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedForeignKeys: Record<string, string>;
        deletedForeignKeys: Record<string, string>;
        alteredForeignKeys: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedCompositePKs: Record<string, string>;
        deletedCompositePKs: Record<string, string>;
        alteredCompositePKs: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedUniqueConstraints: Record<string, string>;
        deletedUniqueConstraints: Record<string, string>;
        alteredUniqueConstraints: Record<string, {
            __old: string;
            __new: string;
        }>;
    }[];
    alteredEnums: never[];
}, {
    alteredTablesWithColumns: {
        name: string;
        schema: string;
        altered: {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }[];
        addedIndexes: Record<string, string>;
        deletedIndexes: Record<string, string>;
        alteredIndexes: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedForeignKeys: Record<string, string>;
        deletedForeignKeys: Record<string, string>;
        alteredForeignKeys: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedCompositePKs: Record<string, string>;
        deletedCompositePKs: Record<string, string>;
        alteredCompositePKs: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedUniqueConstraints: Record<string, string>;
        deletedUniqueConstraints: Record<string, string>;
        alteredUniqueConstraints: Record<string, {
            __old: string;
            __new: string;
        }>;
    }[];
    alteredEnums: never[];
}>;
export declare const diffResultSchemeSQLite: import("zod").ZodObject<{
    alteredTablesWithColumns: import("zod").ZodArray<import("zod").ZodObject<{
        name: import("zod").ZodString;
        schema: import("zod").ZodString;
        altered: import("zod").ZodArray<import("zod").ZodObject<{
            name: import("zod").ZodUnion<[import("zod").ZodString, import("zod").ZodObject<{
                type: import("zod").ZodEnum<["changed"]>;
                old: import("zod").ZodString;
                new: import("zod").ZodString;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: string;
                new: string;
            }, {
                type: "changed";
                old: string;
                new: string;
            }>]>;
            type: import("zod").ZodOptional<import("zod").ZodObject<{
                type: import("zod").ZodEnum<["changed"]>;
                old: import("zod").ZodString;
                new: import("zod").ZodString;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: string;
                new: string;
            }, {
                type: "changed";
                old: string;
                new: string;
            }>>;
            default: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodAny;
            }, "strip", ZodTypeAny, {
                value?: any;
                type: "added";
            }, {
                value?: any;
                type: "added";
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodAny;
            }, "strip", ZodTypeAny, {
                value?: any;
                type: "deleted";
            }, {
                value?: any;
                type: "deleted";
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodAny;
                new: import("zod").ZodAny;
            }, "strip", ZodTypeAny, {
                old?: any;
                new?: any;
                type: "changed";
            }, {
                old?: any;
                new?: any;
                type: "changed";
            }>]>>;
            primaryKey: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "added";
                value: boolean;
            }, {
                type: "added";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "deleted";
                value: boolean;
            }, {
                type: "deleted";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodBoolean;
                new: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: boolean;
                new: boolean;
            }, {
                type: "changed";
                old: boolean;
                new: boolean;
            }>]>>;
            notNull: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "added";
                value: boolean;
            }, {
                type: "added";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "deleted";
                value: boolean;
            }, {
                type: "deleted";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodBoolean;
                new: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: boolean;
                new: boolean;
            }, {
                type: "changed";
                old: boolean;
                new: boolean;
            }>]>>;
            typeSchema: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodString;
            }, "strip", ZodTypeAny, {
                type: "added";
                value: string;
            }, {
                type: "added";
                value: string;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodString;
            }, "strip", ZodTypeAny, {
                type: "deleted";
                value: string;
            }, {
                type: "deleted";
                value: string;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodString;
                new: import("zod").ZodString;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: string;
                new: string;
            }, {
                type: "changed";
                old: string;
                new: string;
            }>]>>;
            onUpdate: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "added";
                value: boolean;
            }, {
                type: "added";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "deleted";
                value: boolean;
            }, {
                type: "deleted";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodBoolean;
                new: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: boolean;
                new: boolean;
            }, {
                type: "changed";
                old: boolean;
                new: boolean;
            }>]>>;
            autoincrement: import("zod").ZodOptional<import("zod").ZodUnion<[import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"added">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "added";
                value: boolean;
            }, {
                type: "added";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"deleted">;
                value: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "deleted";
                value: boolean;
            }, {
                type: "deleted";
                value: boolean;
            }>, import("zod").ZodObject<{
                type: import("zod").ZodLiteral<"changed">;
                old: import("zod").ZodBoolean;
                new: import("zod").ZodBoolean;
            }, "strip", ZodTypeAny, {
                type: "changed";
                old: boolean;
                new: boolean;
            }, {
                type: "changed";
                old: boolean;
                new: boolean;
            }>]>>;
        }, "strict", ZodTypeAny, {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }, {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }>, "many">;
        addedIndexes: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        deletedIndexes: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        alteredIndexes: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodObject<{
            __new: import("zod").ZodString;
            __old: import("zod").ZodString;
        }, "strict", ZodTypeAny, {
            __old: string;
            __new: string;
        }, {
            __old: string;
            __new: string;
        }>>;
        addedForeignKeys: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        deletedForeignKeys: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        alteredForeignKeys: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodObject<{
            __new: import("zod").ZodString;
            __old: import("zod").ZodString;
        }, "strict", ZodTypeAny, {
            __old: string;
            __new: string;
        }, {
            __old: string;
            __new: string;
        }>>;
        addedCompositePKs: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        deletedCompositePKs: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        alteredCompositePKs: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodObject<{
            __new: import("zod").ZodString;
            __old: import("zod").ZodString;
        }, "strip", ZodTypeAny, {
            __old: string;
            __new: string;
        }, {
            __old: string;
            __new: string;
        }>>;
        addedUniqueConstraints: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        deletedUniqueConstraints: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodString>;
        alteredUniqueConstraints: import("zod").ZodRecord<import("zod").ZodString, import("zod").ZodObject<{
            __new: import("zod").ZodString;
            __old: import("zod").ZodString;
        }, "strip", ZodTypeAny, {
            __old: string;
            __new: string;
        }, {
            __old: string;
            __new: string;
        }>>;
    }, "strict", ZodTypeAny, {
        name: string;
        schema: string;
        altered: {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }[];
        addedIndexes: Record<string, string>;
        deletedIndexes: Record<string, string>;
        alteredIndexes: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedForeignKeys: Record<string, string>;
        deletedForeignKeys: Record<string, string>;
        alteredForeignKeys: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedCompositePKs: Record<string, string>;
        deletedCompositePKs: Record<string, string>;
        alteredCompositePKs: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedUniqueConstraints: Record<string, string>;
        deletedUniqueConstraints: Record<string, string>;
        alteredUniqueConstraints: Record<string, {
            __old: string;
            __new: string;
        }>;
    }, {
        name: string;
        schema: string;
        altered: {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }[];
        addedIndexes: Record<string, string>;
        deletedIndexes: Record<string, string>;
        alteredIndexes: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedForeignKeys: Record<string, string>;
        deletedForeignKeys: Record<string, string>;
        alteredForeignKeys: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedCompositePKs: Record<string, string>;
        deletedCompositePKs: Record<string, string>;
        alteredCompositePKs: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedUniqueConstraints: Record<string, string>;
        deletedUniqueConstraints: Record<string, string>;
        alteredUniqueConstraints: Record<string, {
            __old: string;
            __new: string;
        }>;
    }>, "many">;
    alteredEnums: import("zod").ZodArray<import("zod").ZodNever, "many">;
}, "strict", ZodTypeAny, {
    alteredTablesWithColumns: {
        name: string;
        schema: string;
        altered: {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }[];
        addedIndexes: Record<string, string>;
        deletedIndexes: Record<string, string>;
        alteredIndexes: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedForeignKeys: Record<string, string>;
        deletedForeignKeys: Record<string, string>;
        alteredForeignKeys: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedCompositePKs: Record<string, string>;
        deletedCompositePKs: Record<string, string>;
        alteredCompositePKs: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedUniqueConstraints: Record<string, string>;
        deletedUniqueConstraints: Record<string, string>;
        alteredUniqueConstraints: Record<string, {
            __old: string;
            __new: string;
        }>;
    }[];
    alteredEnums: never[];
}, {
    alteredTablesWithColumns: {
        name: string;
        schema: string;
        altered: {
            default?: {
                value?: any;
                type: "added";
            } | {
                value?: any;
                type: "deleted";
            } | {
                old?: any;
                new?: any;
                type: "changed";
            } | undefined;
            type?: {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            onUpdate?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            primaryKey?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            notNull?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            autoincrement?: {
                type: "added";
                value: boolean;
            } | {
                type: "deleted";
                value: boolean;
            } | {
                type: "changed";
                old: boolean;
                new: boolean;
            } | undefined;
            typeSchema?: {
                type: "added";
                value: string;
            } | {
                type: "deleted";
                value: string;
            } | {
                type: "changed";
                old: string;
                new: string;
            } | undefined;
            name: string | {
                type: "changed";
                old: string;
                new: string;
            };
        }[];
        addedIndexes: Record<string, string>;
        deletedIndexes: Record<string, string>;
        alteredIndexes: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedForeignKeys: Record<string, string>;
        deletedForeignKeys: Record<string, string>;
        alteredForeignKeys: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedCompositePKs: Record<string, string>;
        deletedCompositePKs: Record<string, string>;
        alteredCompositePKs: Record<string, {
            __old: string;
            __new: string;
        }>;
        addedUniqueConstraints: Record<string, string>;
        deletedUniqueConstraints: Record<string, string>;
        alteredUniqueConstraints: Record<string, {
            __old: string;
            __new: string;
        }>;
    }[];
    alteredEnums: never[];
}>;
export type Column = TypeOf<typeof columnSchema>;
export type AlteredColumn = TypeOf<typeof alteredColumnSchema>;
export type Enum = TypeOf<typeof enumSchema>;
export type Table = TypeOf<typeof tableScheme>;
export type AlteredTable = TypeOf<typeof alteredTableScheme>;
export type DiffResult = TypeOf<typeof diffResultScheme>;
export type DiffResultMysql = TypeOf<typeof diffResultSchemeMysql>;
export type DiffResultSQLite = TypeOf<typeof diffResultSchemeSQLite>;
export interface ResolverInput<T extends {
    name: string;
}> {
    created: T[];
    deleted: T[];
}
export interface ResolverOutput<T extends {
    name: string;
}> {
    created: T[];
    renamed: {
        from: T;
        to: T;
    }[];
    deleted: T[];
}
export interface ResolverOutputWithMoved<T extends {
    name: string;
}> {
    created: T[];
    moved: {
        name: string;
        schemaFrom: string;
        schemaTo: string;
    }[];
    renamed: {
        from: T;
        to: T;
    }[];
    deleted: T[];
}
export interface ColumnsResolverInput<T extends {
    name: string;
}> {
    tableName: string;
    schema: string;
    created: T[];
    deleted: T[];
}
export interface ColumnsResolverOutput<T extends {
    name: string;
}> {
    tableName: string;
    schema: string;
    created: T[];
    renamed: {
        from: T;
        to: T;
    }[];
    deleted: T[];
}
export declare const applyPgSnapshotsDiff: (json1: PgSchemaSquashed, json2: PgSchemaSquashed, schemasResolver: (input: ResolverInput<Named>) => Promise<ResolverOutput<Named>>, enumsResolver: (input: ResolverInput<Enum>) => Promise<ResolverOutputWithMoved<Enum>>, tablesResolver: (input: ResolverInput<Table>) => Promise<ResolverOutputWithMoved<Table>>, columnsResolver: (input: ColumnsResolverInput<Column>) => Promise<ColumnsResolverOutput<Column>>, prevFull: PgSchema, curFull: PgSchema) => Promise<{
    statements: JsonStatement[];
    sqlStatements: string[];
    _meta: {
        schemas: {};
        tables: {};
        columns: {};
    } | undefined;
}>;
export declare const applyMysqlSnapshotsDiff: (json1: MySqlSchemaSquashed, json2: MySqlSchemaSquashed, tablesResolver: (input: ResolverInput<Table>) => Promise<ResolverOutputWithMoved<Table>>, columnsResolver: (input: ColumnsResolverInput<Column>) => Promise<ColumnsResolverOutput<Column>>, prevFull: MySqlSchema, curFull: MySqlSchema) => Promise<{
    statements: JsonStatement[];
    sqlStatements: string[];
    _meta: {
        schemas: {};
        tables: {};
        columns: {};
    } | undefined;
}>;
export declare const applySqliteSnapshotsDiff: (json1: SQLiteSchemaSquashed, json2: SQLiteSchemaSquashed, tablesResolver: (input: ResolverInput<Table>) => Promise<ResolverOutputWithMoved<Table>>, columnsResolver: (input: ColumnsResolverInput<Column>) => Promise<ColumnsResolverOutput<Column>>) => Promise<{
    statements: JsonStatement[];
    sqlStatements: string[];
    _meta: {
        schemas: {};
        tables: {};
        columns: {};
    } | undefined;
}>;
export {};
